<?php

require_once 'connect.php';
require_once 'inc/messages.php';
require_once 'inc/usuario.php';

// retorna array com lista, ou false se deu erro
function local_estoque_getAll() {
  global $conexao;
  $sql = 'select * from erpc_local_estoque where st_ativo=?';
  $values[] = '1';
  $result = _prepareAndQuery($sql, $values);
  return $result;
}

// retorna array associativo com objeto, ou false se deu erro/não encontrar
function local_estoque_getById($id) {
  global $conexao;
  $sql = 'select le.*, dtl.ds_tipo_local from erpc_local_estoque le join erpc_dom_tipo_local dtl on (dtl.id=le.id_tipo_local) where le.id=? and le.st_ativo=1';
  $values[] = $id;
  $result = _prepareAndQuery($sql, $values);
  if ($result !== false) {
    if (count($result) === 1) {
      $result = $result[0];
      $itens = local_enderecos_getById($id);
      // se não tiver itens, cria um array vazio
      if ($itens === false) {
        $result = false;
        addError('Erro ao carregar os itens');
      } else {
        $result['itens'] = $itens;
        // já formato os campos aqui? por hora sim...
        foreach($result as $k => $v) {
          $result[$k] = sgcws_format_field($k, $v);
        }
      }
    } else {
      $result = false;
      addError('Id não encontrado');
    }
  }

  return $result;
}

// retorna array associativo com objeto, ou false se deu erro/não encontrar
function local_enderecos_getById($id_pai) {
  global $conexao;
  $sql = 'select * from erpc_local_enderecos where id_local_estoque=?';
  $values[] = $id_pai;
  $result = _prepareAndQuery($sql, $values);
  return $result;
}

// insere novo
function local_estoque_insert($local_estoque, &$error=null) {
  global $conexao;


  $dt = new DateTime();
  $local_estoque['dh_alteracao'] = $dt->format('Y-m-d H:i:s');

  // addError('<pre>$local_estoque:'.var_export($local_estoque, true).'</pre>');
  $ok = false;
  $sql = 'insert into erpc_local_estoque ';
  $campos = array('id_tipo_local', 'ds_local', 'dh_alteracao', 'id_usuario', 'st_ativo');
  $values = array();
  foreach($campos as $campo) {
    $values[] = $local_estoque[$campo];
  }
  $sql .= '(' . implode(',', $campos) . ') values (' . trim(str_repeat('?,', count($values)), ',') . ')';

  $ok = _prepareAndExecute($sql, $values, $error);
  if ($ok !== false) {
    $local_estoque['id'] = mysqli_insert_id($conexao);
    $ok = local_enderecos_insert($local_estoque, $error);
    if ($ok && $error === null) {
      addMessage('Inserido com sucesso');
    }
  }
  return $ok;
}

// insere novo item
function local_enderecos_insert($local_estoque, &$error=null) {

  global $conexao;

  $ok = false;
  $itens = $local_estoque['itens'];
  if (count($itens) > 0) {
    $sql = 'insert into erpc_local_enderecos ';
    $campos = array('id', 'id_local_estoque', 'ds_endereco', 'ds_prioridade', 'st_ativo');
    $sql .= '(' . implode(',', $campos) . ') values ';
    $sql .= '(' . trim(str_repeat('?,', count($campos)), ',') . ')';
    $values = array();
    foreach($itens as $item) {
      if (!empty($item['id'])) {
        $item['id_local_estoque'] = $local_estoque['id'];
        foreach($campos as $campo) {
          if (in_array($campo, ['st_ativo'])) {
            $values[] = isset($item[$campo]) ? '1' : '0';
          } else {
            $values[] = $item[$campo];
          }
        }
      }
    }
    // remove última ','
    if (empty($values)) {
      // nada para inserir
      $ok = true;
    } else {
      $ok = _prepareAndExecute($sql, $values, $error, true);
    }
  } else {
    // nada para inserir
    $ok = true;
  }
  return $ok;
}

// atualiza o objeto passado no bd
function local_estoque_update($local_estoque) {
  global $conexao;

  $dt = new DateTime();
  $local_estoque['dh_alteracao'] = $dt->format('Y-m-d H:i:s');

  $ok = false;
  $sql = 'update erpc_local_estoque set ';
  $campos = array('id_tipo_local', 'ds_local', 'dh_alteracao', 'id_usuario', 'st_ativo');
  $values = array();
  foreach($campos as $campo) {
    $sql .= $campo . '=?,';
    $values[] = $local_estoque[$campo];
  }

  $sql = trim($sql, ',');
  $sql .= ' where id = ?';
  $values[] = $local_estoque['id'];
  $ok = _prepareAndExecute($sql, $values);
  if ($ok !== false) {
    $ok = local_enderecos_update($local_estoque);
    if ($ok !== false) {
      addMessage('Atualizado com sucesso');
    }
  }
  return $ok;
}

function local_estoque_alterar_status($local_estoque) {

  $itens = $local_estoque['itens'];
  
  if (count($itens) > 0) {
      foreach($itens as $item) {
        $sql = 'select * from erpc_produtos_saldos where id_produto = ? and id_local = ?';
        $values = array();
        $values[] = $item['id'];
        $values[] = $local_estoque['id'];
        $result = _prepareAndQuery($sql, $values);
        if (count($result) >= 1) {
          $ok = produtos_saldo_update($item, $local_estoque['id']);
        }else{
          if($item['st_bloq'] == 1){
            $ok = produtos_saldo_insert($item,  $local_estoque['id']);
          }
        }     
      }
  } 
  addMessage('Bloqueados com sucesso');
  return $ok;
}

function produtos_saldo_insert($item, $id_local){
  $sql = 'insert into erpc_produtos_saldos ';
    $campos = array('id_produto', 'id_local', 'st_bloq');
    $sql .= '(' . implode(',', $campos) . ') values ';
    $sql .= '(' . trim(str_repeat('?,', count($campos)), ',') . ')';
    $values = array();
    $values[] = $item['id'];
    $values[] = $id_local;
    $values[] = $item['st_bloq'];
    $ok = _prepareAndExecute($sql, $values, $error, true);
    return $ok;
}

function produtos_saldo_update($item, $id_local){
  $bloq = isset($item['st_bloq']) ? '1' : '0';
  $sql = 'update erpc_produtos_saldos set st_bloq = ' . $bloq . ' WHERE id_produto = ? and id_local = ?';
  $values[] = $item['id'];
  $values[] = $id_local;
  echo 'update';
  $ok = _prepareAndExecute($sql, $values);
}

// atualiza os itens do objeto passado no bd, apaga tudo e insere de novo
function local_enderecos_update($local_estoque) {
  global $conexao;
  $ok = false;
  $sql = 'delete from erpc_local_enderecos where id_local_estoque=?';
  $values = array($local_estoque['id']);
  $ok = _prepareAndExecute($sql, $values);
  if ($ok !== false) {
    $ok = local_enderecos_insert($local_estoque);
  }
  return $ok;
}

function local_estoque_delete($local_estoque) {
  global $conexao;
  $ok = false;
  
  $sql = 'update erpc_local_estoque set st_ativo = 0, id_usuario = ?, dh_alteracao = ?';

  $dt = new DateTime();
  $user = getLoggedUser();
  $values = array($user['id'],$dt->format('Y-m-d H:i:s'), $local_estoque['id']);
  $sql .= ' where id = ?';
  
  $values[] = $local_estoque['id'];
  $ok = _prepareAndExecute($sql, $values);

  if ($ok !== false) {
    $ok = local_enderecos_delete($local_estoque);
  }
  if ($ok !== false) {
    addMessage('Removido com sucesso');
  }
  return $ok;
}

function local_enderecos_delete($local_estoque) {
  global $conexao;
  $ok = false;
  $sql = 'update erpc_local_enderecos set st_ativo = 0 where id_local_estoque = ?';
  
  $values = array($local_estoque['id']);
  $ok = _prepareAndExecute($sql, $values);
  return $ok;
}

function local_estoque_create() {
  $user = getLoggedUser();
  $dt = new DateTime();

  $local_estoque = array(
    'id' => '',
    'id_tipo_local' => '',
    'ds_local' => '',
    'dh_alteracao' => $dt->format('Y-m-d H:i:s'),
    'id_usuario' => $user['id'],
    'st_ativo' => '1',
    'itens' => array(),
    'ds_tipo_local' => '',
  );
  return $local_estoque;
}

function local_enderecos_create() {
  $local_estoque = array(
    'id' => '',
    'id_local_estoque' => '',
    'ds_endereco' => '',
    'ds_prioridade' => '',
    'nr_saldo' => '',
    'st_ativo' => '1',
  );
  return $local_estoque;
}